local function UnderlineText(start, length)
	editor:StartStyling(start,INDICS_MASK)
	if length == -1 then
		editor:SetStyling(editor.Length, 0)
	else
		editor:SetStyling(length,INDIC2_MASK)
	end
end

local sText = props['CurrentSelection']
local flag = 0
if (sText == '') then
	sText = props['CurrentWord']
	flag = SCFIND_WHOLEWORD
end

if string.len(sText) > 0 then
	editor:MarkerDeleteAll(1)
	UnderlineText(0, -1)
	local s,e = editor:findtext(sText,flag,0)
	local count = 0
	if(s~=nil)then
		local m = editor:LineFromPosition(s) - 1
		while s do
			local l = editor:LineFromPosition(s)
			UnderlineText(s, e-s)
			count = count + 1
			if l ~= m then
				local str = string.gsub(' '..editor:GetLine(l),'%s+',' ')
				editor:MarkerAdd(l,1)
				print(props['FileNameExt']..':'..(l + 1)..':\t'..str)
				m = l
			end
			s,e = editor:findtext(sText,flag,e+1)
		end
		print('> Number of Occurences: '..count)
	else
		print(sText..' Not Founded ?')
	end
else
	editor:MarkerDeleteAll(1)
	UnderlineText(0, -1)
end

--~ if props.CurrentSelection ~= "" then
--~ 	for m in editor:match( "^.*" .. props.CurrentSelection .. ".*$", SCFIND_REGEXP, 0) do
--~ 		print(props.FileNameExt .. ":" .. (editor:LineFromPosition(m.pos)+1) .. ":" .. m.text)
--~ 	end
--~ else
--~ 	print("The InternalGrep script only searchs for selected text")
--~ end
