// Generated by TinyPG v1.2 available at www.codeproject.com

using System;
using System.Collections.Generic;

namespace CWrapper.LispWrapper
{
    #region Parser

    public partial class Parser 
    {
        private Scanner scanner;
        private ParseTree tree;
        
        public Parser(Scanner scanner)
        {
            this.scanner = scanner;
        }

        public ParseTree Parse(string input)
        {
            tree = new ParseTree();
            return Parse(input, tree);
        }

        public ParseTree Parse(string input, ParseTree tree)
        {
            scanner.Init(input);

            this.tree = tree;
            ParseStart(tree);
            tree.Skipped = scanner.Skipped;

            return tree;
        }

        private void ParseStart(ParseNode parent) // NonTerminalSymbol: Start
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.Start), "Start");
            parent.Nodes.Add(node);


             // Concat Rule
            tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE, TokenType.EXPR_CHAR, TokenType.DBL_QUOTES, TokenType.COMMA); // Option Rule
            if (tok.Type == TokenType.OPEN_PAREN
                || tok.Type == TokenType.OPEN_BRACKET
                || tok.Type == TokenType.OPEN_BRACE
                || tok.Type == TokenType.EXPR_CHAR
                || tok.Type == TokenType.DBL_QUOTES
                || tok.Type == TokenType.COMMA)
            {
                Parsesexpr(node); // NonTerminal Rule: sexpr
            }

             // Concat Rule
            tok = scanner.Scan(TokenType.EOF); // Terminal Rule: EOF
            if (tok.Type != TokenType.EOF)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.EOF.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: Start

        private void Parsesexpr(ParseNode parent) // NonTerminalSymbol: sexpr
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.sexpr), "sexpr");
            parent.Nodes.Add(node);

            tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE, TokenType.EXPR_CHAR, TokenType.DBL_QUOTES, TokenType.COMMA); // Choice Rule
            switch (tok.Type)
            { // Choice Rule
                case TokenType.OPEN_PAREN:
                case TokenType.OPEN_BRACKET:
                case TokenType.OPEN_BRACE:
                    tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE); // ZeroOrMore Rule
                    while (tok.Type == TokenType.OPEN_PAREN
                        || tok.Type == TokenType.OPEN_BRACKET
                        || tok.Type == TokenType.OPEN_BRACE)
                    {
                        Parselist(node); // NonTerminal Rule: list
                    tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE); // ZeroOrMore Rule
                    }
                    break;
                case TokenType.EXPR_CHAR:
                    Parseatom(node); // NonTerminal Rule: atom
                    break;
                case TokenType.DBL_QUOTES:
                    Parsestr_quote(node); // NonTerminal Rule: str_quote
                    break;
                case TokenType.COMMA:
                    tok = scanner.LookAhead(TokenType.COMMA); // ZeroOrMore Rule
                    while (tok.Type == TokenType.COMMA)
                    {
                        Parsecomment(node); // NonTerminal Rule: comment
                    tok = scanner.LookAhead(TokenType.COMMA); // ZeroOrMore Rule
                    }
                    break;
                default:
                    tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found.", 0x0002, 0, tok.StartPos, tok.StartPos, tok.Length));
                    break;
            } // Choice Rule

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: sexpr

        private void Parselist(ParseNode parent) // NonTerminalSymbol: list
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.list), "list");
            parent.Nodes.Add(node);

            tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE); // Choice Rule
            switch (tok.Type)
            { // Choice Rule
                case TokenType.OPEN_PAREN:

                     // Concat Rule
                    tok = scanner.Scan(TokenType.OPEN_PAREN); // Terminal Rule: OPEN_PAREN
                    if (tok.Type != TokenType.OPEN_PAREN)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.OPEN_PAREN.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);

                     // Concat Rule
                    Parsemembers(node); // NonTerminal Rule: members

                     // Concat Rule
                    tok = scanner.Scan(TokenType.CLOSE_PAREN); // Terminal Rule: CLOSE_PAREN
                    if (tok.Type != TokenType.CLOSE_PAREN)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.CLOSE_PAREN.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);
                    break;
                case TokenType.OPEN_BRACKET:

                     // Concat Rule
                    tok = scanner.Scan(TokenType.OPEN_BRACKET); // Terminal Rule: OPEN_BRACKET
                    if (tok.Type != TokenType.OPEN_BRACKET)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.OPEN_BRACKET.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);

                     // Concat Rule
                    Parsemembers(node); // NonTerminal Rule: members

                     // Concat Rule
                    tok = scanner.Scan(TokenType.CLOSE_BRACKET); // Terminal Rule: CLOSE_BRACKET
                    if (tok.Type != TokenType.CLOSE_BRACKET)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.CLOSE_BRACKET.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);
                    break;
                case TokenType.OPEN_BRACE:

                     // Concat Rule
                    tok = scanner.Scan(TokenType.OPEN_BRACE); // Terminal Rule: OPEN_BRACE
                    if (tok.Type != TokenType.OPEN_BRACE)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.OPEN_BRACE.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);

                     // Concat Rule
                    Parsemembers(node); // NonTerminal Rule: members

                     // Concat Rule
                    tok = scanner.Scan(TokenType.CLOSE_BRACE); // Terminal Rule: CLOSE_BRACE
                    if (tok.Type != TokenType.CLOSE_BRACE)
                        tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.CLOSE_BRACE.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
                    n = node.CreateNode(tok, tok.ToString() );
                    node.Token.UpdateRange(tok);
                    node.Nodes.Add(n);
                    break;
                default:
                    tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found.", 0x0002, 0, tok.StartPos, tok.StartPos, tok.Length));
                    break;
            } // Choice Rule

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: list

        private void Parsemembers(ParseNode parent) // NonTerminalSymbol: members
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.members), "members");
            parent.Nodes.Add(node);

            tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE, TokenType.EXPR_CHAR, TokenType.DBL_QUOTES, TokenType.COMMA); // ZeroOrMore Rule
            while (tok.Type == TokenType.OPEN_PAREN
                || tok.Type == TokenType.OPEN_BRACKET
                || tok.Type == TokenType.OPEN_BRACE
                || tok.Type == TokenType.EXPR_CHAR
                || tok.Type == TokenType.DBL_QUOTES
                || tok.Type == TokenType.COMMA)
            {
                Parsesexpr(node); // NonTerminal Rule: sexpr
            tok = scanner.LookAhead(TokenType.OPEN_PAREN, TokenType.OPEN_BRACKET, TokenType.OPEN_BRACE, TokenType.EXPR_CHAR, TokenType.DBL_QUOTES, TokenType.COMMA); // ZeroOrMore Rule
            }

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: members

        private void Parsestr_quote(ParseNode parent) // NonTerminalSymbol: str_quote
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.str_quote), "str_quote");
            parent.Nodes.Add(node);


             // Concat Rule
            tok = scanner.Scan(TokenType.DBL_QUOTES); // Terminal Rule: DBL_QUOTES
            if (tok.Type != TokenType.DBL_QUOTES)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.DBL_QUOTES.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

             // Concat Rule
            tok = scanner.Scan(TokenType.QUOTES_CHAR); // Terminal Rule: QUOTES_CHAR
            if (tok.Type != TokenType.QUOTES_CHAR)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.QUOTES_CHAR.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

             // Concat Rule
            tok = scanner.Scan(TokenType.DBL_QUOTES); // Terminal Rule: DBL_QUOTES
            if (tok.Type != TokenType.DBL_QUOTES)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.DBL_QUOTES.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: str_quote

        private void Parseatom(ParseNode parent) // NonTerminalSymbol: atom
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.atom), "atom");
            parent.Nodes.Add(node);

            tok = scanner.Scan(TokenType.EXPR_CHAR); // Terminal Rule: EXPR_CHAR
            if (tok.Type != TokenType.EXPR_CHAR)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.EXPR_CHAR.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: atom

        private void Parsecomment(ParseNode parent) // NonTerminalSymbol: comment
        {
            Token tok;
            ParseNode n;
            ParseNode node = parent.CreateNode(scanner.GetToken(TokenType.comment), "comment");
            parent.Nodes.Add(node);


             // Concat Rule
            tok = scanner.Scan(TokenType.COMMA); // Terminal Rule: COMMA
            if (tok.Type != TokenType.COMMA)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.COMMA.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

             // Concat Rule
            tok = scanner.Scan(TokenType.COMMENT_CHAR); // Terminal Rule: COMMENT_CHAR
            if (tok.Type != TokenType.COMMENT_CHAR)
                tree.Errors.Add(new ParseError("Unexpected token '" + tok.Text.Replace("\n", "") + "' found. Expected " + TokenType.COMMENT_CHAR.ToString(), 0x1001, 0, tok.StartPos, tok.StartPos, tok.Length));
            n = node.CreateNode(tok, tok.ToString() );
            node.Token.UpdateRange(tok);
            node.Nodes.Add(n);

            parent.Token.UpdateRange(node.Token);
        } // NonTerminalSymbol: comment


    }

    #endregion Parser
}
