using System;

namespace WinCommand
{
    /// <summary>
    /// Summary description for StatusUpdatedEventArgs.
    /// </summary>
    public class StatusUpdatedEventArgs : EventArgs
    {
        private string _msg;

        public string Message
        {
            get
            {
                return _msg;
            }
        }

        public StatusUpdatedEventArgs(string message)
        {
            _msg = message;
        }
    }

    public class DebuggerUpdatedEventArgs : EventArgs
    {
        private string _msg;

        public string Message
        {
            get
            {
                return _msg;
            }
        }

        public DebuggerUpdatedEventArgs(string message)
        {
            _msg = message;
        }
    }

    public class CommandEnteredEventArgs : EventArgs
    {
        string command;
        public CommandEnteredEventArgs(string command)
        {
            this.command = command;
        }

        public string Command
        {
            get { return command; }
        }
    }

    public class PipeEventArgs : EventArgs
    {
        public enum PipeEvent
        {
            PipeStarted,
            RequestHandled,
            Listening,
            Message
        }

        private string _msg;
        private PipeEvent _pEvent;

        public string Message
        {
            get
            {
                return _msg;
            }
        }

        public PipeEvent pEvent
        {
            get
            {
                return _pEvent;
            }
        }

        public PipeEventArgs(string message, PipeEvent pEvent)
        {
            _msg = message;
            _pEvent = pEvent;
        }
    }
}